unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, CoolTrayIcon, MMSystem, ImgList,Registry, WinSkinData, ComObj,
  ScktComp;


 type
  PDevBroadcastHdr  = ^DEV_BROADCAST_HDR;
  DEV_BROADCAST_HDR = packed record
    dbch_size: DWORD;
    dbch_devicetype: DWORD;
    dbch_reserved: DWORD;
  end;

  PDevBroadcastDeviceInterface  = ^DEV_BROADCAST_DEVICEINTERFACE;
  DEV_BROADCAST_DEVICEINTERFACE = record
    dbcc_size: DWORD;
    dbcc_devicetype: DWORD;
    dbcc_reserved: DWORD;
    dbcc_classguid: TGUID;
    dbcc_name: short;
  end;

const
  GUID_DEVINTERFACE_USB_DEVICE: TGUID = '{A5DCBF10-6530-11D2-901F-00C04FB951ED}';
  DBT_DEVICEARRIVAL          = $8000;          // system detected a new device
  DBT_DEVICEREMOVECOMPLETE   = $8004;          // device is gone
  DBT_DEVTYP_DEVICEINTERFACE = $00000005;      // device interface class

type
  TForm1 = class(TForm)
    CoolTrayIcon1: TCoolTrayIcon;
    PopupMenu1: TPopupMenu;
    Munitor1: TMenuItem;
    Desligar1: TMenuItem;
    GerenciadodeTarefas1: TMenuItem;
    DesligarComputador1: TMenuItem;
    Desligar2: TMenuItem;
    Reiniciar1: TMenuItem;
    FazerLogOff1: TMenuItem;
    DriveCDDVD1: TMenuItem;
    Abrir1: TMenuItem;
    Fechar1: TMenuItem;
    Sair1: TMenuItem;
    Abilitar1: TMenuItem;
    Desabilitar1: TMenuItem;
    DesligarForado1: TMenuItem;
    procedure Sair1Click(Sender: TObject);
    procedure Desligar2Click(Sender: TObject);
    procedure Reiniciar1Click(Sender: TObject);
    procedure FazerLogOff1Click(Sender: TObject);
    procedure Abrir1Click(Sender: TObject);
    procedure Fechar1Click(Sender: TObject);
    procedure Desligar1Click(Sender: TObject);
    procedure Desabilitar1Click(Sender: TObject);
    procedure Abilitar1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DesligarForado1Click(Sender: TObject);
  private
        FWindowHandle: HWND;
  protected
    procedure WndProc(var Msg: TMessage);
    function USBRegister: Boolean;
    procedure WMDeviceChange(var Msg: TMessage);
  public
    r: Pointer;
  end;

var
  Form1: TForm1;
  procedure DisableTaskMgr(bTF: Boolean);   External'dcad.dll';
  procedure Desligar;                       External'Power.dll';
  procedure Desligar_forcado;               External'Power.dll';
  procedure Logoff;                         External'Power.dll';
  procedure Reiniciar;                      External'Power.dll';
implementation

{$R *.dfm}

function TForm1.USBRegister: Boolean;
var
  dbi: DEV_BROADCAST_DEVICEINTERFACE;
  Size: Integer;
begin
  Result := False;
  Size := SizeOf(DEV_BROADCAST_DEVICEINTERFACE);
  ZeroMemory(@dbi, Size);
  dbi.dbcc_size := Size;
  dbi.dbcc_devicetype := DBT_DEVTYP_DEVICEINTERFACE;
  dbi.dbcc_reserved := 0;
  dbi.dbcc_classguid  := GUID_DEVINTERFACE_USB_DEVICE;
  dbi.dbcc_name := 0;
r := RegisterDeviceNotification(FWindowHandle, @dbi,DEVICE_NOTIFY_WINDOW_HANDLE);
  if Assigned(r) then
  Result := True;
end;

procedure TForm1.WMDeviceChange(var Msg: TMessage);
var
  devType: Integer;
  Datos: PDevBroadcastHdr;
begin
  if (Msg.wParam = DBT_DEVICEARRIVAL) or (Msg.wParam = DBT_DEVICEREMOVECOMPLETE) then
  begin
    Datos := PDevBroadcastHdr(Msg.lParam);
    devType := Datos^.dbch_devicetype;
    if devType = DBT_DEVTYP_DEVICEINTERFACE then
    begin // USB Device
      if Msg.wParam = DBT_DEVICEARRIVAL then
      begin
       ShowMessage('DISPOSITIVO USB INSERIDO.');
      end
      else
      begin
        ShowMessage('DISPOSITIVO USB REMOVIDO.');
      end;
    end;
  end;
end;

procedure TForm1.WndProc(var Msg: TMessage);
begin
 if (Msg.Msg = WM_DEVICECHANGE) then
  begin
    try
      WMDeviceChange(Msg);
    except
      Application.HandleException(Self);
    end;
  end
  else
    Msg.Result := DefWindowProc(FWindowHandle, Msg.Msg, Msg.wParam, Msg.lParam);
end;

procedure TForm1.Sair1Click(Sender: TObject);
begin
application.Terminate;
end;

procedure TForm1.Desligar2Click(Sender: TObject);
begin
Desligar;
end;

procedure TForm1.Reiniciar1Click(Sender: TObject);
begin
Reiniciar;
end;

procedure TForm1.FazerLogOff1Click(Sender: TObject);
begin
Logoff;
end;

procedure TForm1.Abrir1Click(Sender: TObject);
begin
MciSendString('Set CdAudio Door Open',nil,0,Handle) //Abrir CD
end;

procedure TForm1.Fechar1Click(Sender: TObject);
begin
MciSendString('Set CdAudio Door Closed',nil,0,Handle); //Fechar CD
end;

procedure TForm1.Desligar1Click(Sender: TObject);
begin
SendMessage(Application.Handle, wm_SysCommand, SC_MonitorPower, 1);// 
end;


procedure TForm1.Desabilitar1Click(Sender: TObject);
begin
DisableTaskMgr(True);
end;

procedure TForm1.Abilitar1Click(Sender: TObject);
begin
DisableTaskMgr(false);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FWindowHandle := AllocateHWnd(WndProc);
  USBRegister;

end;

procedure TForm1.DesligarForado1Click(Sender: TObject);
begin
Desligar_forcado;
end;

end.
